AchievementPyromaster = class(Turbine.UI.Control)
function AchievementPyromaster:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Gust of Wind"] = true,
        ["Lightning Strike"] = true,
        ["Light of the Rising Dawn"] = true,
        ["Beacon of Hope"] = true,
        ["Water-lore"] = true,
        ["Knowledge of the Lore-master"] = true,
        ["Wind-lore"] = true,
        ["Frost-lore"] = true,
        ["Storm-lore"] = true,
        ["Herb-lore"] = true,
        ["Air-lore"] = true,
        ["Blinding Flash"] = true,
        ["Bane Flare"] = true,
        ["Clever Escape"] = true,
        ["Share the Power"] = true,
        ["Wisdom of the Council"] = true,
        ["Back from the Brink"] = true,
        ["Sticky Tar"] = true,
        ["Call to the Valar"] = true,
        ["Ancient Craft"] = true,
        ["Dispel Corruption"] = true,
        ["Power of Knowledge"] = true,
        ["Test of Will"] = true,
        ["The Ancient Master"] = true,
        ["Warding Knowledge"] = true,
        ["Staff-strike"] = true,
        ["Staff-sweep"] = true,
        ["Improved Staff-sweep"] = true,
        ["Sign of Power: Righteousness"] = true,
        ["Sign of Power: Vigilance"] = true,
        ["Sign of Power: See All Ends"] = true,
        ["Improved Sign of Power: Command"] = true,
        ["Sign of Power: Command"] = true,
        ["Wizard's Frost"] = true,
        ["Knowledge of Cures"] = true,
        ["A Murder of Crows"] = true,
        ["Nature's Fury"] = true,
        ["Lightning-storm"] = true,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.PyroCommand = Turbine.ShellCommand()
    function self.PyroCommand:Execute()
        HardcoreHandler:GetAchievementHint("Pyromaster")
    end

    Turbine.Shell.AddCommand("hardcorepyromaster", self.PyroCommand)

    ChatOutput("Use the command /hardcorepyromaster to see a list of affected skills")


    self.handler = handler

    self:SetCallbacks()
end

function AchievementPyromaster:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then

            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Pyromaster", "Usage of non fire skill", 0x410081FC)
            end))
        end
    end
    
    self.hitCallback = AddCallback(ChatEventHandler, "PlayerCombat", function(args)
        if args.Source == self.playerName and self.skillList[args.SkillName] then
            self.handler:Fail("Pyromaster", "Usage of non fire skill", 0x410081FC)
        end
    end)
end

function AchievementPyromaster:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
    RemoveCallback(ChatEventHandler, "PlayerCombat", self.hitCallback)
end

function AchievementPyromaster:Refresh()
    self:Unload()
    self:SetCallbacks()
end

function AchievementPyromaster:GetHint()
    ChatOutput("<rgb=#005500>Only loremaster skills that have skill-type fire can be used, pets are also allowed.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end